<!DOCTYPE html SYSTEM "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <title>Eclipse TGcrud Bindings Overview</title>

        <style type="text/css">
            .TODO {
                padding-left: 10pt;
                background-color: #ffffaa;
                color: black;
                border: 1px solid #ddddff;
                border-left: 5pt solid blue;
            }
            .TODO:before {
                content: "TODO ";
                font-weight: bold;
                color: blue;
            }
            .important {
                border-left: 5pt solid red;
                padding-left: 10pt;
            }
            .pseudocode {
                 
                font-family: serif;
                font-style: italic;
                font-size: inherit;
                color: darkblue;
                list-style: none;
            }
        </style>
    </head>
    <body>
		<p>See the <a href="index.html">Overview</a> for the current architecture
		and usage hints. Please also see the Javadocs.
        <h1>Implementation</h1>

		<p class="important">This section is partly out of date.</p>

        <h3>Unique TextGridObjects</h3>
        <p class="def">TextGridObjects are unique, i.e. there is never more than
            one TextGridObject per referable object in TextGrid.</p>

        <p><code>TextGridObject</code> does not have a public constructor. The
            preferred mode of getting one is to adapt an existing representation
            of the object to <code>TextGridObject.<b>class</b></code>.
            Alternatively, you may call one of the factory functions
                    <code>TextGridObject.<i>create</i></code>, which take either
            an URI or a metadata block. </p>

        <object data="object-interaction-impl.svg" type="image/svg+xml" height="332" width="345" style="float: right;">
        	<img src="object-interaction-impl.svg" alt="Object interaction (implementation issue)"/>
        </object>
        
        <div class="TODO">
            <h3>Modifying Metadata</h3>
            <p>Modifying Metadata works as follows:</p>
            <ol>
                <li>Obtain a TextGridObject</li>
                <li>Register a modification listener with the TextGridObject.</li>
                <li>Fill your UI with the information from the TextGridObject.</li>
                <li>If the listener fires, you should update your local fields.</li>
                <li>If your local fields change, you should update the
                    TextGridObject</li>
            </ol>
            <h4>Saving metadata</h4>
            <p>Metadata and their corresponding objects are tightly coupled. If
                you (re-)load an object's contents (e.g. <code class="java"
                    >IFile.getContents()</code>), the metadata is (re-)loaded
                from the Grid. If you save an object to the grid, its metadata
                will be saved, as well; and the TextGridObject will be updated
                with the metadata from the grid). <span class="TODO"
                    >Additionally, it is possible to save only the
                metadata.</span>
            </p>
            <h3>Creating an object</h3>
            <p>When objects are created, the following phases are possible:</p>
            <ol>
                <li>The object is created, and it's metadata is still
                    incomplete.</li>
                <li>The object is first stored to the grid (→ TGcrud#create)</li>
                <li>The object is updated later</li>
            </ol>
            <h4>Preliminary object creation</h4>
            <p>When the object's metadata is not yet complete or the object has
                not been stored to the grid for some other reason, it does not
                have its final <code>textgrid:</code> URI. Instead, the object
                is assigned a temporary URI by calling <code class="TODO"
                    >TextGridObject#create(OMElement)</code> or
                TextGridObject#create(). This temporary URI has the form
                        <code>textgrid-temp:<var title="or any other integer"
                    >42</var></code>.</p>
            <h4>Saving the object (<code>TGcrud#create</code>)</h4>
            <p> When you first save the object (either by calling
                    <code>ITextGridObject.saveMetadata()</code> or
                    <code>IFile.setContents(...)</code>) we need the additional
                metadata provided. If it is, TGcrud#create is called with the
                metadata and (optionally) the data. </p>
            <p>TGcrud#create returns with a new URI from the
                <code>textgrid:</code> scheme. The TextGridObject stays the
                same, the IFile's link is modified. Clients addressing the
                TextGridObject with the “old” URI (from textgrid-temp:) will
                still receive the TextGridObject, nut the latter's
                    <code>getURI()</code> method will return the new URI (this
                works by <em>adding</em> a link from the new URI to the registry
                instead of replacing the temporary URI).</p>
            <h4>Editors and <em>Save as …</em></h4>
            <p> The API for saving files leaves the <em>Save as …</em>
                functionality basically to the individual editors: There are
                methods ISaveablePart#doSave(IProgressMonitor) and
                ISaveablePart#doSaveAs(). doSave saves the IEditorInput, ie it
                usually calls IFile#setContents, which will result in an
                IFileStore#openOutputStream and consecutive save operations.
                With doSaveAs, it's up to the <em>editor</em> to invoke a »Save
                as …« dialog. </p>
            <p> If it is not possible to hijack the general save-as dialog, I
                suggest that we implement the save as functionality separately,
                controlled from the EFS layer. I.e., the EFS layer pops up a
                dialog asking for the new metadata: </p>
            <pre class="pseudocode">
<span class="action">File → Save to new TextGridObject …</span>
  TextGridObject(activeEditor.getEditorInput).saveAs := true
  activeEditor.doSave()
            </pre>
            <p>This will finally result in a call to
                TGFileStore.openOutputStream(), in which:</p>
            <pre class="pseudocode">
    if TextGridObject(this).saveAs then
      newMetadata := showMetadataWizard(TextGridObject(this), NEW_VERSION)
      TGcrud.create(newMetadata, this)
            </pre>
            <p class="TODO">Now we must tell the EditorPart that it is working
                with a different object now, since it wouldn't expect that.
                Options are: </p>
            <dl>
                <dt>Changing the link.</dt>
                <dd>We simply change the IFile by setting it to a different link
                    (using <code>createLink(newURI))</code>. Maybe we also have
                    to fire a “resource changed” event or something like that.
                    Disadvantage: This is not intuitive, because the user then
                    works with a different file, but not with a different file
                    representation in the GUI. </dd>
                <dt>Reopening the editor.</dt>
                <dd>We close the calling editor and open it anew, with the new
                    object's new IFile. Disadvantage: Closing and reopening the
                    editor is probably neither what the user nor what the editor
                    expect. Additionally, we lose the editor's state as far as
                    it is not stored with the object (cursor position etc.)</dd>
                <dt>A specialized interface.</dt>
                <dd>Does only work with our editors, not with others'.</dd>
            </dl>
        </div>
    </body>
</html>
